﻿Imports System.Xml
Imports C1.Win.C1FlexGrid

Public Class Form1
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        C1FlexGridGroupPanel1.FlexGrid = C1FlexGrid1
        C1FlexGrid1.DataSource = GetDataSource()
        C1FlexGrid1.AllowSorting = AllowSortingEnum.SingleColumn

        '    C1FlexGrid1.Rows.Count = 9
        'C1FlexGrid1.Cols.Count = 4
        'C1FlexGrid1.Cols.Fixed = 1
        'C1FlexGrid1(0, 1) = "Id"
        'C1FlexGrid1(0, 2) = "Name"
        'C1FlexGrid1(0, 3) = "Position"

        'C1FlexGrid1(1, 1) = 1
        'C1FlexGrid1(1, 2) = "Peter"
        'C1FlexGrid1(1, 3) = "D"

        'C1FlexGrid1(2, 1) = 2
        'C1FlexGrid1(2, 2) = "George"
        'C1FlexGrid1(2, 3) = "D"

        'C1FlexGrid1(3, 1) = 3
        'C1FlexGrid1(3, 2) = "Emily"
        'C1FlexGrid1(3, 3) = "C"

        'C1FlexGrid1(4, 1) = 4
        'C1FlexGrid1(4, 2) = "Craig"
        'C1FlexGrid1(4, 3) = "I"

        'C1FlexGrid1(5, 1) = 5
        'C1FlexGrid1(5, 2) = "Steve"
        'C1FlexGrid1(5, 3) = "F"

        'C1FlexGrid1(6, 1) = 6
        'C1FlexGrid1(6, 2) = "John"
        'C1FlexGrid1(6, 3) = "I"

        'C1FlexGrid1(7, 1) = 7
        'C1FlexGrid1(7, 2) = "Fred"
        'C1FlexGrid1(7, 3) = "B"


        '    C1FlexGrid1(8, 1) = 8
        'C1FlexGrid1(8, 2) = "Mary"
        'C1FlexGrid1(8, 3) = "D"

        'C1FlexGrid1.Sort(New ExampleComparer(C1FlexGrid1, SortFlags.Descending, 3))
    End Sub

    Public Class ExampleComparer
        Implements IComparer
        Private Const Order As String = "DCBFI"
        Private _flex As C1FlexGrid
        Private _desc As Boolean
        Private _col As Integer
        Public Sub New(ByVal flex As C1FlexGrid, ByVal order As SortFlags, column As Integer)
            _flex = flex
            _desc = (order And SortFlags.Descending) <> 0
            _col = column
        End Sub

        Public Function Compare(a As Object, b As Object) As Integer Implements IComparer.Compare
            Dim texteA As String = _flex.GetDataDisplay(CType(a, Row).Index, _col)
            Dim texteB As String = _flex.GetDataDisplay(CType(b, Row).Index, _col)

            Dim indexA As Integer = Order.IndexOf(texteA)
            Dim indexB As Integer = Order.IndexOf(texteB)
            Dim icomp As Integer
            If (indexA < indexB) Then
                icomp = -1
            ElseIf (indexB < indexA) Then
                icomp = 1
            Else
                icomp = 0
            End If
            Return If(_desc, -icomp, icomp)
        End Function

    End Class

    'Private Sub flex_BeforeSort(sender As Object, e As SortColEventArgs) Handles C1FlexGrid1.BeforeSort
    '  Return
    '  If e.Col = 3 Then
    '    C1FlexGrid1.Sort(New ExampleComparer(C1FlexGrid1, e.Order, e.Col))
    '    e.Handled = True
    '  End If
    'End Sub

    ''' <summary>
    ''' Sample data for grid
    ''' </summary>
    Private Function GetDataSource() As Object
        Dim dt As New DataTable()

        dt.Columns.Add("Id")
        dt.Columns.Add("Name")
        dt.Columns.Add("Position")
        dt.Columns.Add("Site")

        dt.Rows.Add(1, "Peter", "D", "Toronto")
        dt.Rows.Add(2, "George", "D", "Venice")
        dt.Rows.Add(3, "Emily", "C", "Paris")
        dt.Rows.Add(4, "Craig", "I", "Berlin")
        dt.Rows.Add(5, "Steve", "F", "Milan")
        dt.Rows.Add(6, "John", "I", "Tokyo")
        dt.Rows.Add(7, "Fred", "B", "Rome")
        dt.Rows.Add(8, "Mary", "D", "Madrid")


        Return dt
    End Function

    Private Sub saveGrid_Click(sender As Object, e As EventArgs) Handles saveGrid.Click
        Dim zXML = New Text.StringBuilder
        Using writer As XmlWriter = XmlWriter.Create(zXML)
            writer.WriteStartElement("FlexGrid")
            writer.WriteStartElement("Definition", "")
            writer.WriteAttributeString("Filter", C1FlexGrid1.FilterDefinition)
            writer.WriteAttributeString("Sort", C1FlexGrid1.SortDefinition)
            writer.WriteAttributeString("Group", C1FlexGrid1.GroupDefinition)
            writer.WriteEndElement()
            writer.WriteEndElement()
            writer.Flush()
        End Using
        IO.File.WriteAllText(C1FlexGrid1.Name & ".xml", zXML.ToString())
    End Sub

    Private Sub restore_Click(sender As Object, e As EventArgs) Handles restore.Click
        Dim zXML As New Text.StringBuilder
        Dim content As String = IO.File.ReadAllText(C1FlexGrid1.Name & ".xml")
        zXML.Append(content)
        Using stream As IO.TextReader = New IO.StringReader(zXML.ToString)
            Using reader As XmlReader = XmlReader.Create(stream)
                reader.ReadToFollowing("Definition")
                C1FlexGrid1.GroupDefinition = IIf(reader.GetAttribute("Group") = Nothing, String.Empty, reader.GetAttribute("Group"))
                C1FlexGrid1.SortDefinition = IIf(reader.GetAttribute("Sort") = Nothing, String.Empty, reader.GetAttribute("Sort"))
                C1FlexGrid1.FilterDefinition = IIf(reader.GetAttribute("Filter") = Nothing, String.Empty, reader.GetAttribute("Filter"))
                reader.Close()
            End Using
        End Using
    End Sub
End Class
